with Ada.IO_Exceptions;
private with Ada.Calendar;
private with Ada.Directories;
private with Ada.Processes;
private with Ada.Strings.Unbounded;
package Birdeyes.HTTP is
	
	type Connection is limited private;
	
	procedure Start (
		Object : in out Connection;
		URI : in String;
		Name : in String); -- local file name
	
	procedure Wait (
		Object : in out Connection;
		Modified : out Boolean;
		Overwrite_Now : in Boolean := True);
	
	function Temporary_Name (Object : Connection) return String;
	
	Not_Available : exception;
	
	Data_Error : exception
		renames Ada.IO_Exceptions.Data_Error;
	
private
	
	type Connection is record
		Temporary_Directory : aliased Ada.Strings.Unbounded.Unbounded_String;
		Temporary_Name : aliased Ada.Strings.Unbounded.Unbounded_String;
		Name : aliased Ada.Strings.Unbounded.Unbounded_String;
		Saved_Time : Ada.Calendar.Time;
		Saved_Size : Ada.Directories.File_Size;
		Wget : Ada.Processes.Process;
	end record;
	
end Birdeyes.HTTP;
