with Ada.Calendar;
with Ada.IO_Exceptions;
with Ada.Text_IO;
with Birdeyes.Syndications.Management;
with Birdeyes.URI;
package Birdeyes.LIRS is
	-- LIRS specification:
	-- http://www.t-base.ne.jp/~wind/natsu/doc/LIRS.html
	
	procedure Import (
		Syndication_Manager : in out Syndications.Management.Manager;
		File : in Ada.Text_IO.File_Type;
		Time : in Ada.Calendar.Time;
		Success_Item : out URI.Lists.List;
		Failure_Item : out URI.Lists.List);
	
	procedure Export (
		Syndication_Manager : in out Syndications.Management.Manager;
		File : in Ada.Text_IO.File_Type;
		Item : in URI.Lists.List;
		Agent_URI : in String);
	
	Data_Error : exception
		renames Ada.IO_Exceptions.Data_Error;
	
end Birdeyes.LIRS;
