procedure Birdeyes.Pages.Index_Page (
	Output : not null access Ada.Streams.Root_Stream_Type'Class;
	Template : in String;
	Message : in String := "";
	User_Manager : in Users.Management.Manager;
	User_Id : in String)
is
	procedure Handle (
		Output : not null access Ada.Streams.Root_Stream_Type'Class;
		Tag : in String;
		Contents : in Web.Producers.Template) is
	begin
		if Tag = "message" then
			declare
				procedure Handle (
					Output : not null access Ada.Streams.Root_Stream_Type'Class;
					Tag : in String;
					Contents : in Web.Producers.Template) is
				begin
					if Tag = "text" then
						Web.Write_In_HTML (Output, Web.XHTML, Message);
					else
						Raise_Unknown_Tag (Tag);
					end if;
				end Handle;
			begin
				if Message'Length /= 0 then
					Web.Producers.Produce (Output, Contents, Handler => Handle'Access);
				end if;
			end;
		elsif Tag = "userpanel" then
			if User_Id'Length /= 0 then
				declare
					procedure Handle (
						Output : not null access Ada.Streams.Root_Stream_Type'Class;
						Tag : in String;
						Contents : in Web.Producers.Template) is
					begin
						if Tag = "id" then
							Web.Write_In_HTML (Output, Web.XHTML, User_Id);
						else
							Raise_Unknown_Tag (Tag);
						end if;
					end Handle;
				begin
					Web.Producers.Produce (Output, Contents, "logon", Handler => Handle'Access);
				end;
			else
				Web.Producers.Produce (Output, Contents, "logoff");
			end if;
		elsif Tag = "userlist" then
			declare
				procedure Process (Id : in String) is
					procedure Handle (
						Output : not null access Ada.Streams.Root_Stream_Type'Class;
						Tag : in String;
						Contents : in Web.Producers.Template) is
					begin
						if Tag = "href_antenna" then
							Web.Write_Begin_Attribute (Output, "href");
							Web.Write_Query_In_Attribute (
								Output,
								Web.XHTML,
								Parameters_To_View_Page (Id));
							Web.Write_End_Attribute (Output);
						elsif Tag = "name_antenna" then
							Web.Write_In_HTML (Output, Web.XHTML, Id & "'s antenna");
						else
							Raise_Unknown_Tag (Tag);
						end if;
					end Handle;
				begin
					Web.Producers.Produce (Output, Contents, Handler => Handle'Access);
				end Process;
			begin
				Users.Management.Iterate (User_Manager, Process'Access);
			end;
		else
			Raise_Unknown_Tag (Tag);
		end if;
	end Handle;
begin
	Web.Producers.Produce (Output, Read (Template), Handler => Handle'Access);
end Birdeyes.Pages.Index_Page;
