procedure Birdeyes.Pages.Register_Page (
	Output : not null access Ada.Streams.Root_Stream_Type'Class;
	Template : in String;
	Base_Page : in Pages.Base_Page;
	View_User_Id : in String := "";
	New_User_Id : in String;
	New_User_Password : in String)
is
	procedure Handle (
		Output : not null access Ada.Streams.Root_Stream_Type'Class;
		Tag : in String;
		Contents : in Web.Producers.Template) is
	begin
		if Tag = "id" then
			Web.Write_In_HTML (Output, Web.XHTML, New_User_Id);
		elsif Tag = "parameters" then
			declare
				Parameters : Web.Query_Strings;
			begin
				case Base_Page is
					when Index =>
						Parameters := Parameters_To_Index_Page;
					when View =>
						Parameters := Parameters_To_View_Page (View_User_Id => View_User_Id);
				end case;
				Web.Write_Query_In_HTML (
					Output,
					Web.XHTML,
					Parameters);
			end;
		elsif Tag = "value_newid" then
			Web.Write_Begin_Attribute (Output, "value");
			Web.Write_In_Attribute (Output, Web.XHTML, New_User_Id);
			Web.Write_End_Attribute (Output);
		elsif Tag = "value_newpassword" then
			Web.Write_Begin_Attribute (Output, "value");
			Web.Write_In_Attribute (Output, Web.XHTML, New_User_Password);
			Web.Write_End_Attribute (Output);
		else
			Raise_Unknown_Tag (Tag);
		end if;
	end Handle;
begin
	Web.Producers.Produce (Output, Read (Template), Handler => Handle'Access);
end Birdeyes.Pages.Register_Page;
