with Birdeyes.HTTP;
with Birdeyes.URI;
package Birdeyes.Syndications.Management is
	
	type Manager (<>) is limited private;
	
	function Create (Path : Static_String_Access) return Manager;
	
	procedure Query (
		Object : in out Manager;
		URI : in String;
		Info : out Syndication_Info);
	
	procedure Query (
		Object : in out Manager;
		URI : in String;
		Info : out Syndication_Info;
		Articles : out Article_Lists.List);
	
	procedure Start_Update (
		Object : in out Manager;
		URI : in String;
		Connection : in out HTTP.Connection);
	
	procedure Wait_Update (
		Object : in out Manager;
		URI : in String;
		Connection : in out HTTP.Connection;
		Time : in Ada.Calendar.Time;
		Info : out Syndication_Info;
		Articles : out Article_Lists.List);
	
	-- for one
	procedure Get (
		Object : in out Manager;
		URI : in String;
		Time : in Ada.Calendar.Time;
		Info : out Syndication_Info;
		Articles : out Article_Lists.List);
	
	Connect_Count : constant := 4; -- connection count at same time
	
	function Select_For_Update (
		Object : Manager;
		URI_List : URI.Lists.List;
		Num : Natural := Connect_Count)
		return URI.Lists.List;
	
	-- for multi
	procedure Get (
		Object : in out Manager;
		URI_List : in URI.Lists.List;
		Update_URI_List : in URI.Lists.List;
		Time : in Ada.Calendar.Time;
		Result : out Syndication_Info_And_Articles_Lists.List);
	
	Not_Available : exception
		renames HTTP.Not_Available;
	
private
	
	type Manager is limited record
		Path : Static_String_Access;
	end record;
	
end Birdeyes.Syndications.Management;
