with Birdeyes.Calendar.Serialization;
package body Birdeyes.Syndications.Serialization is
	
	procedure IO (
		Serializer : not null access Standard.Serialization.Serializer;
		Item : in out Syndication_Info)
	is
		use Standard.Serialization;
		use Calendar.Serialization.Time_IO;
		use Stream_Element_Offset_IO;
		use Syndication_Version_IO;
		use History_List_IO;
		procedure History_List_Callback (
			Serializer : not null access Standard.Serialization.Serializer;
			Item : in out History) is
		begin
			for P in IO (Serializer) loop
				IO (Serializer, "modified-time", Item.Modified_Time,
					Default => Calendar.Null_Time);
			end loop;
		end History_List_Callback;
	begin
		for P in IO (Serializer) loop
			IO (Serializer, "uri", Item.URI);
			IO (Serializer, "version", Item.Version);
			IO (Serializer, "link", Item.Link);
			IO (Serializer, "title", Item.Title);
			IO (Serializer, "author", Item.Author);
			IO (Serializer, "content-length", Item.Content_Length);
			IO (Serializer, "last-tried-time", Item.Last_Tried_Time,
				Default => Calendar.Null_Time);
			IO (Serializer, "last-avail-time", Item.Last_Avail_Time,
				Default => Calendar.Null_Time);
			IO (Serializer, "last-detected-time", Item.Last_Detected_Time,
				Default => Calendar.Null_Time);
			IO (Serializer, "history", Item.History,
				Callback => History_List_Callback'Access);
		end loop;
	end IO;
	
end Birdeyes.Syndications.Serialization;
